/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   Conversor de caixas postais Mailbox para Maildir                    
   Programado por Lucas Priori                                         
   Versao: 0.1b                                                        
                                                                       
   Compilar:                                                           
   gcc mb2md.c -o mb2md                                                
                                                                       
  ******************************************************************   
  mb2md  uma ferramenta que converte as caixas postais Mailbox de um  
  servidor de emails para o formato Maildir                            
  Este programa  uma ferramenta do projeto MTA Sceo                   
  Copyright (C) 2008  Lucas Priori                                     
                                                                       
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or    
  (at your option) any later version.                                  
                                                                       
  This program is distributed in the hope that it will be useful,      
  but WITHOUT ANY WARRANTY; without even the implied warranty of       
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
  GNU General Public License for more details.                         
                                                                       
  You should have received a copy of the GNU General Public License    
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<dirent.h>
#include<sys/stat.h>
#include<time.h>
#include<utime.h>



#define VERSAO "0.1b"
#define TAM_buffer 2048
#define USUARIO "sceo"
#define PMDIR "/home/mail"
#define MDIR "Maildir"
#define PMBOX "/var/spool/mail"


// Base de converso com acentos 
char base_comacentos[256]={
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','-','.','_',
 '0','1','2','3','4','5','6','7','8','9','_','_','_','_','_','_',
 '_','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
 'P','Q','R','S','T','U','V','W','X','Y','Z','_','_','_','_','_',
 '_','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
 'p','q','r','s','t','u','v','w','x','y','z','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '','','','','A','A','_','','','','','E','','','','I',
 '_','N','O','','','','O','_','_','','','','','_','_','_',
 '','','','','a','a','_','','','','','e','','','','i',
 '_','_','','','','','o','_','_','','','','','_','_','_'
};
// Base de converso sem acentos 
char base_semacentos[256]={
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','-','.','_',
 '0','1','2','3','4','5','6','7','8','9','_','_','_','_','_','_',
 '_','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
 'P','Q','R','S','T','U','V','W','X','Y','Z','_','_','_','_','_',
 '_','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
 'p','q','r','s','t','u','v','w','x','y','z','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 '_','_','_','_','_','_','_','_','_','_','_','_','_','_','_','_',
 'A','A','A','A','A','A','_','C','E','E','E','E','I','I','I','I',
 '_','N','O','O','O','O','O','_','_','U','U','U','U','_','_','_',
 'a','a','a','a','a','a','_','c','e','e','e','e','i','i','i','i',
 '_','_','o','o','o','o','o','_','_','u','u','u','u','_','_','_'
};


char *op_sa=base_comacentos;

//---------------------------------------------------
//Funcao para comparar duas strings desconciderando  
//a diferena entre maisculas e minsculas          
//Retornos:                                          
//0 = strings so iguais                             
//1 = strings so diferentes                         
int cmp_str(char *string1,char *string2,int num_bytes){
 if(!num_bytes){
  if(string1[0]==string2[0])return 0;
  return 1;
 }
 int ret_val=0;
 asm(
  "movl %0,%%edi           \n"
  "movl %1,%%esi           \n"
 "CMP_STR_proxbyte:        \n"
  "movb (%%esi),%%al       \n"
  "cmpb (%%edi),%%al       \n"
  "jne  CMP_STR_trocar     \n"
 "CMP_STR_incr:            \n"
  "incl %%esi              \n"
  "incl %%edi              \n"
  "loop CMP_STR_proxbyte   \n"
  "jmp  CMP_STR_term       \n"
 "CMP_STR_trocar:          \n"
  "xorb $32,%%al           \n"
  "cmpb (%%edi),%%al       \n"
  "je   CMP_STR_incr       \n"
 "CMP_STR_term:            \n"
  "testw %%cx,%%cx         \n"
  "jz   CMP_STR_fim        \n"
  "movw $1,%%cx            \n"
 "CMP_STR_fim:             \n"
  "movw  %%cx,%3           \n"
  :
  :"m"(string1),"m"(string2),"c"(num_bytes),"m"(ret_val)
  :"edi","esi","eax"
 );
 return ret_val;
}

//--- Variavel de controle --- 
//    da funcao cpl            
char *cpl_orig;
char *cpl_dest;
//---------------------------------------------------
// Funcao para separar em linhas um buffer lido de   
// arquivo                                           
int cpl(unsigned int *tamanho,unsigned int limite){
 int ret_val=0;
 asm(
  "movl %1,%%edi           \n"
  "movl %2,%%esi           \n"
  "movl %3,%%ecx           \n"
  "testl %%ecx,%%ecx       \n"
  "jz CPL_arrumar          \n"
 "CPL_volta:               \n"
  "movb (%%esi),%%al       \n"
  "incl %%esi              \n"
  "cmpb $10,%%al           \n"
  "je CPL_finalizar        \n"
  "testb %%al,%%al         \n"
  "jz CPL_zero             \n"
  "movb %%al,(%%edi)       \n"
  "incl %%edi              \n"
  "loop CPL_volta          \n"
 "CPL_arrumar:             \n"      // Limite da linha atingido
  "movb (%%esi),%%al       \n"
  "incl %%esi              \n"
  "cmpb $10,%%al           \n"
  "jne CPL_ar_prox         \n"
 "CPL_finalizar:           \n"
  "movl %4,%%ecx           \n"
  "jmp CPL_fim             \n"
 "CPL_ar_prox:             \n"
  "testb %%al,%%al         \n"
  "jnz CPL_arrumar         \n"
 "CPL_zero:                \n"
  "movw $1,%5              \n"
 "CPL_fim:                 \n"
  "movb $0,(%%edi)         \n"
  "movl %%edi,%1           \n"
  "movl %%esi,%2           \n"
  "movl %%ecx,%0           \n"
 
  :"=r"(*tamanho)
  :"m"(cpl_dest),"m"(cpl_orig),"r"(*tamanho),"r"(limite),"m"(ret_val)
  :"eax","edi","esi","ecx"
 );
 return ret_val;
}



//---------------------------------------------------
// Converte uma mailbox em maildir                   
// Retornos:                                         
// 0 = Sucesso                                       
// 1 = Erro                                          
char conv_mbox2maildir(char *servidor,char *mbox_ori,char *mdir_base,char *dominio, char *usuario,char *maildir,char *pasta){
 FILE *arq_ori=NULL,*arq_dest=NULL;
 time_t tempo;
 struct tm tempo_tmp;
 struct utimbuf utime_buffer;
 
 char buffer[TAM_buffer+1];
 char linha[TAM_buffer+1];
 char dest_cam_cxp[TAM_buffer];
 char dest_cxp[TAM_buffer];
 char ren_email[TAM_buffer];
 char ult_linha_branco=1;
 char lendo_header=0;
 char *ptr_aux1;
 char str_date[500];
 int tamanho=TAM_buffer;
 int ret;
 int b_lidos=0;
 int email_lido=0;
 unsigned int pid_cont=501;
 unsigned int tam_linha=0;
 unsigned long long int num_emails=0;
 unsigned long long int tam_cxp=0;
 unsigned long long int tam_cxp_maildirsize=0;
 unsigned long long int num_emails_maildirsize=0;
 
 snprintf(dest_cam_cxp,sizeof(dest_cam_cxp),"%s/%s/%s/%s",mdir_base,dominio,usuario,maildir);
 // -- Criando o caminho Maildir -- 
 if(!pasta){
  snprintf(buffer,sizeof(buffer),"mkdir -p %s",dest_cam_cxp);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/cur",dest_cam_cxp);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/new",dest_cam_cxp);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/tmp",dest_cam_cxp);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"chown %s. %s/%s",USUARIO,mdir_base,dominio);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"chown -R %s. %s/%s/%s",USUARIO,mdir_base,dominio,usuario);
  system(buffer);
 }else {
  // -- Convertendo caracteres invalidos no nome da pasta --
  ptr_aux1=pasta;
  while(*ptr_aux1){
   *ptr_aux1=op_sa[(unsigned char)*ptr_aux1];
   ptr_aux1++;
  }
  //--------------------------------------------------------
  if(!strcmp(pasta,"sent") || !strcmp(pasta,"trash") || !strcmp(pasta,"spam") || !strcmp(pasta,"draft"))*pasta=*pasta-32;   //Convertendo prim. caractere para Maiusculo
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/.%s",dest_cam_cxp,pasta);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/.%s/cur",dest_cam_cxp,pasta);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/.%s/new",dest_cam_cxp,pasta);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"mkdir -p %s/.%s/tmp",dest_cam_cxp,pasta);
  system(buffer);
  snprintf(buffer,sizeof(buffer),"chown -R %s. %s/.%s",USUARIO,dest_cam_cxp,pasta);
  system(buffer);
 }
 arq_ori=fopen(mbox_ori,"rb");
 if(!arq_ori){
  printf("[%s] nao encontrada",mbox_ori);
  return 1;
 }
 cpl_dest=linha;
 num_emails=0;
 utime_buffer.modtime=0;
 utime_buffer.actime=0;
 while(!feof(arq_ori)){
  b_lidos=fread(&buffer,1,TAM_buffer,arq_ori);
  buffer[b_lidos]=0;
  cpl_orig=buffer;
  while(!(ret=cpl(&tamanho,TAM_buffer))){
   tam_linha=cpl_dest-linha;
   tam_cxp=tam_cxp+tam_linha;
   cpl_dest=linha;
   if(ult_linha_branco && !strncmp(linha,"From ",5)){
    // Novo email encontrado
    num_emails++;
    lendo_header=1;
    if(arq_dest)fclose(arq_dest);
    if(email_lido){
     // Status do ultimo email estava como lido 
     // Vamos alterar o status do email no nome 
     snprintf(ren_email,sizeof(ren_email),"%sS",dest_cxp);
     rename(dest_cxp,ren_email);
     strcpy(dest_cxp,ren_email);
    }
    if(utime_buffer.modtime){
     // Alterando data do arquivo
     utime(dest_cxp,&utime_buffer);
    }
    time(&tempo);
    if(!pasta)snprintf(dest_cxp,sizeof(dest_cxp),"%s/cur/%ld.%d.%s:2,",dest_cam_cxp,tempo,pid_cont,servidor);
    else snprintf(dest_cxp,sizeof(dest_cxp),"%s/.%s/cur/%ld.%d.%s:2,",dest_cam_cxp,pasta,tempo,pid_cont,servidor);
    pid_cont++;
    arq_dest=fopen(dest_cxp,"wb");
    ult_linha_branco=0;
    email_lido=0;
    utime_buffer.modtime=0;
    utime_buffer.actime=0;
   }else {
    if(!linha[0]){
     ult_linha_branco=1;
     lendo_header=0;
    }else ult_linha_branco=0;
    if(lendo_header){
     if(!cmp_str(linha,"Status:",7)){
      if(strchr(&linha[7],'R'))email_lido=1;
     }else if(!cmp_str(linha,"Date:",5)){
      ptr_aux1=&linha[5];
      while(*ptr_aux1<48 || *ptr_aux1>57)ptr_aux1++;
      strptime(ptr_aux1, "%d %b %Y %H:%M:%S", &tempo_tmp);
      utime_buffer.actime=mktime(&tempo_tmp);
      utime_buffer.modtime=utime_buffer.actime;
     }
    }
    if(arq_dest){
     // Gravando linha
     linha[tam_linha]=10;
     tam_linha++;
     fwrite(&linha,1,tam_linha,arq_dest);
    }
   }
  }
 }
 if(arq_dest)fclose(arq_dest);
 if(email_lido){
  // Status do ultimo email estava como lido 
  // Vamos alterar o status do email no nome 
  snprintf(ren_email,sizeof(ren_email),"%sS",dest_cxp);
  rename(dest_cxp,ren_email);
  strcpy(dest_cxp,ren_email);
 }
 if(utime_buffer.modtime){
  // Alterando data do arquivo
  utime(dest_cxp,&utime_buffer);
 }
 fclose(arq_ori);
 if(num_emails){
  if(pasta)snprintf(buffer,sizeof(buffer),"chown -R %s. %s/.%s/cur",USUARIO,dest_cam_cxp,pasta);
  else snprintf(buffer,sizeof(buffer),"chown -R %s. %s/cur",USUARIO,dest_cam_cxp);
  system(buffer);
 }
 printf("%llu E-mails. %llu Mbytes",num_emails,tam_cxp/1024/1024);
 // Atualizando maildirsize
 snprintf(buffer,sizeof(buffer),"%s/maildirsize",dest_cam_cxp);
 arq_dest=fopen(buffer,"rb");
 if(arq_dest){
  fread(&linha,1,sizeof(buffer),arq_dest);
  ptr_aux1=linha;
  while(*ptr_aux1<'0' || *ptr_aux1>'9')ptr_aux1++;
  sscanf(ptr_aux1,"%llu %llu",&tam_cxp_maildirsize,&num_emails_maildirsize);
  fclose(arq_dest);
 }
 arq_dest=fopen(buffer,"wb");
 if(arq_dest){
  snprintf(linha,sizeof(buffer),"chown %s. %s/maildirsize",USUARIO,dest_cam_cxp);
  system(linha);
  num_emails+=num_emails_maildirsize;
  tam_cxp+=tam_cxp_maildirsize;
  b_lidos=sprintf(buffer,"\n%12llu %12llu\n",tam_cxp,num_emails);
  fwrite(&buffer,1,b_lidos,arq_dest);
  fclose(arq_dest);
 }else {
  printf("Erro criando maildirsize\n");
  return 1;
 }
 return 0;
}

//---------------------------------------------------
//                 Funcao principal                  
//---------------------------------------------------
int main(int argc, char *argv[]){
 FILE *arq_lista;
 DIR *dir;
 struct dirent *entr;
 struct stat dados_entr;
 char buffer_local[TAM_buffer];
 char linha_local[TAM_buffer];
 char op_s[500]={0};
 char op_l[500]={0};
 char op_pmdir[500]=PMDIR;
 char op_mdir[500]=MDIR;
 char op_pmbox[500]=PMBOX;
 char op_pmboxf[500]={0};
 char op_u[100]=USUARIO;
 char op_cp=0;
 char dominio[300];
 char usuario[200];
 char cam_mbox[2000];
 char cam_mboxf[2000];
 char *ptr_aux1;
 char *ptr_aux2;
 char byte=0;
 int b_lidos=0;
 unsigned int cont1=0;
 unsigned int cont2=0;
 
 if(argc==1){
  Ajuda:
  printf("Conversor de Mailbox para Maildir v %s\n",VERSAO);
  printf("Opcoes:\n\n");
  printf(" -s      ---> Nome do servidor\n");
  printf(" -l      ---> Arquivo que contem uma lista com os emails e seus\n              respectivos usuarios\n");
  printf("              O arquivo deve ser uma lista com a sintaxe: <email completo> <usuario do sistema>\n");
  printf("              Veja mais abaixo um exemplo de um arquivo de lista\n");
  printf(" -pmdir  ---> Diretorio base para as novas pastas Maildir\n              Padrao: %s\n",PMDIR);
  printf(" -mdir   ---> Diretorio Maildir dentro da pasta HOME do usuario\n              Padrao: %s\n",MDIR);
  printf(" -pmbox  ---> Diretorio das Inbox Mailbox\n              Padrao: %s\n",PMBOX);
  printf(" -pmboxf ---> Diretorio das pastas particulares Mailbox\n");
  printf(" -sa     ---> Retira os acentos/cedilhas dos nomes das pastas durante a conversao\n");
  printf(" -cp     ---> Copia todos os arquivos ocultos do diretorio HOME Mailbox para o diretorio HOME Maildir\n");
  printf(" -u      ---> Usuario que ser usado para as permisses das pastas Maildir\n              Padrao: %s\n",USUARIO);
  printf("\nExemplo:\n\n");
  printf(" ./mbox2maildir -s mail.server1 -l lista.txt -pmdir /var/mail/sites -mdir Maildir -pmbox /var/spool/mail -pmboxf /home/mail -u sceo\n");
  printf("\nExemplo de arquivo de lista:\n\n");
  printf("contato@dominio.com.br rafael\n");
  printf("adm@dominio.com.br denis\n");
  printf("gessica@dominio.com.br gessica\n");
  printf("postmaster@meudominio.com.br postmaster\n");
  printf("abuse@dominio.com.br post_01\n");
  printf("\n\n");
  return 0;
 }
 for(cont1=1;cont1<argc;cont1++){
  if(!strcmp(argv[cont1],"-s")){
   // -- Servidor --
   if(argv[cont1+1]){
    strncpy(op_s,argv[cont1+1],sizeof(op_s));
    cont1++;
   }
  }else if(!strcmp(argv[cont1],"-l")){
   // -- Arquivo de lista --
   if(argv[cont1+1]){
    strncpy(op_l,argv[cont1+1],sizeof(op_l));
    cont1++;
   }
  }else if(!strcmp(argv[cont1],"-pmdir")){
   // -- Caminho Maildir --
   if(argv[cont1+1]){
    strncpy(op_pmdir,argv[cont1+1],sizeof(op_pmdir));
    cont1++;
   }
  }else if(!strcmp(argv[cont1],"-mdir")){
   // -- Diretorio Maildir --
   if(argv[cont1+1]){
    strncpy(op_mdir,argv[cont1+1],sizeof(op_mdir));
    cont1++;
   }
  }else if(!strcmp(argv[cont1],"-pmbox")){
   // -- Caminho Mbox --
   if(argv[cont1+1]){
    strncpy(op_pmbox,argv[cont1+1],sizeof(op_pmbox));
    cont1++;
   }
  }else if(!strcmp(argv[cont1],"-pmboxf")){
   // -- Caminho das pastas particulares Mbox --
   if(argv[cont1+1]){
    strncpy(op_pmboxf,argv[cont1+1],sizeof(op_pmboxf));
    cont1++;
   }
  }else if(!strcmp(argv[cont1],"-sa")){
   // -- Retira os acentos das pastas --
   op_sa=base_semacentos;
  }else if(!strcmp(argv[cont1],"-cp")){
   // -- Copia os arq ocultos --
   op_cp=1;
  }else if(!strcmp(argv[cont1],"-u")){
   // -- Usuario --
   if(argv[cont1+1]){
    strncpy(op_u,argv[cont1+1],sizeof(op_u));
    cont1++;
   }
  }
 }
 if(!op_s[0] || !op_l[0]){
  printf("Opo -s e -l obrigatorias\n");
  goto Ajuda;
 }
 //--------------------------------------------
 //          Iniciando a conversao             
 //--------------------------------------------
 arq_lista=fopen(op_l,"rb");
 if(!arq_lista){
  printf("Nao foi possivel abrir o arquivo de lista %s\n",op_l);
  return 1;
 }
 while(!feof(arq_lista)){
  b_lidos=fread(&buffer_local,1,TAM_buffer,arq_lista);
  for(cont1=0;cont1<b_lidos;cont1++){
   if(buffer_local[cont1]==10){
    linha_local[cont2]=0;
    ptr_aux1=strchr(linha_local,' ');
    if(!ptr_aux1)ptr_aux1=strchr(linha_local,9);      // 9 = TAB
    if(ptr_aux1){
     byte=*ptr_aux1;
     *ptr_aux1=0;
     ptr_aux1++;
     while(*ptr_aux1==byte)ptr_aux1++;
     if(linha_local[0]!='@'){
      ptr_aux2=strchr(linha_local,'@');
      if(ptr_aux2){
       *ptr_aux2=0;
       strcpy(usuario,linha_local);
       ptr_aux2++;
       strcpy(dominio,ptr_aux2);
       ptr_aux2--;
       *ptr_aux2='@';
       snprintf(cam_mbox,sizeof(cam_mbox),"%s/%s",op_pmbox,ptr_aux1);
       printf("[%s --> %s/%s/%s]    ",cam_mbox,op_pmdir,dominio,usuario);
       fflush(stdout);
       conv_mbox2maildir(op_s,cam_mbox,op_pmdir,dominio,usuario,op_mdir,NULL);
       printf("\n");
       if(op_pmboxf[0]){
        // Convertendo pastas particulares
        snprintf(cam_mboxf,sizeof(cam_mboxf),"%s/%s",op_pmboxf,ptr_aux1);
        dir=opendir(cam_mboxf);
        if(dir){
         while((entr = readdir(dir)) != NULL){
          if(entr->d_name[0]!='.'){
           snprintf(cam_mboxf,sizeof(cam_mboxf),"%s/%s/%s",op_pmboxf,ptr_aux1,entr->d_name);
           stat(cam_mboxf,&dados_entr);
           if(entr->d_name[0]!='.' && !(dados_entr.st_mode & S_IFDIR)){
            // Arquivo 
            printf("   %s   ",cam_mboxf);
            fflush(stdout);
            conv_mbox2maildir(op_s,cam_mboxf,op_pmdir,dominio,usuario,op_mdir,entr->d_name);
            printf("\n");
           }
          }
         }
         closedir(dir);
         if(op_cp){
          // Copiando Arquivos ocultos 
          snprintf(linha_local,sizeof(linha_local),"cp %s/%s/.* %s/%s/%s",op_pmboxf,ptr_aux1,op_pmdir,dominio,usuario);
          system(linha_local);
          snprintf(linha_local,sizeof(linha_local),"chown %s. %s/%s/%s/.*",op_u,op_pmdir,dominio,usuario);
          system(linha_local);
         }
        }
       }
      }else printf("Ignorando [%s]\n",linha_local);
     }
    }
    cont2=0;
   }else if(buffer_local[cont1]!=13){
    linha_local[cont2]=buffer_local[cont1];
    cont2++;
   }
  }
 }
 fclose(arq_lista);
 return 0;
}




